# coding: utf-8

"""
    Python client for GIG based clouds (pc4g)

    RESTful api client to a GIG based cloud.  # noqa: E501

    OpenAPI spec version: v1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pc4g.configuration import Configuration


class Customer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'billable': 'bool',
        'company_information': 'object',
        'customer_id': 'str',
        'external_customer_id': 'str',
        'id': 'str',
        'organization': 'str',
        'status': 'str'
    }

    attribute_map = {
        'billable': 'billable',
        'company_information': 'company_information',
        'customer_id': 'customer_id',
        'external_customer_id': 'external_customer_id',
        'id': 'id',
        'organization': 'organization',
        'status': 'status'
    }

    def __init__(self, billable=None, company_information=None, customer_id=None, external_customer_id=None, id=None, organization=None, status=None, _configuration=None):  # noqa: E501
        """Customer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._billable = None
        self._company_information = None
        self._customer_id = None
        self._external_customer_id = None
        self._id = None
        self._organization = None
        self._status = None
        self.discriminator = None

        if billable is not None:
            self.billable = billable
        if company_information is not None:
            self.company_information = company_information
        if customer_id is not None:
            self.customer_id = customer_id
        if external_customer_id is not None:
            self.external_customer_id = external_customer_id
        if id is not None:
            self.id = id
        if organization is not None:
            self.organization = organization
        if status is not None:
            self.status = status

    @property
    def billable(self):
        """Gets the billable of this Customer.  # noqa: E501

        Customer is billable  # noqa: E501

        :return: The billable of this Customer.  # noqa: E501
        :rtype: bool
        """
        return self._billable

    @billable.setter
    def billable(self, billable):
        """Sets the billable of this Customer.

        Customer is billable  # noqa: E501

        :param billable: The billable of this Customer.  # noqa: E501
        :type: bool
        """

        self._billable = billable

    @property
    def company_information(self):
        """Gets the company_information of this Customer.  # noqa: E501

        Company Information  # noqa: E501

        :return: The company_information of this Customer.  # noqa: E501
        :rtype: object
        """
        return self._company_information

    @company_information.setter
    def company_information(self, company_information):
        """Sets the company_information of this Customer.

        Company Information  # noqa: E501

        :param company_information: The company_information of this Customer.  # noqa: E501
        :type: object
        """

        self._company_information = company_information

    @property
    def customer_id(self):
        """Gets the customer_id of this Customer.  # noqa: E501

        Customer ID  # noqa: E501

        :return: The customer_id of this Customer.  # noqa: E501
        :rtype: str
        """
        return self._customer_id

    @customer_id.setter
    def customer_id(self, customer_id):
        """Sets the customer_id of this Customer.

        Customer ID  # noqa: E501

        :param customer_id: The customer_id of this Customer.  # noqa: E501
        :type: str
        """

        self._customer_id = customer_id

    @property
    def external_customer_id(self):
        """Gets the external_customer_id of this Customer.  # noqa: E501

        Reference to this customer in an external system  # noqa: E501

        :return: The external_customer_id of this Customer.  # noqa: E501
        :rtype: str
        """
        return self._external_customer_id

    @external_customer_id.setter
    def external_customer_id(self, external_customer_id):
        """Sets the external_customer_id of this Customer.

        Reference to this customer in an external system  # noqa: E501

        :param external_customer_id: The external_customer_id of this Customer.  # noqa: E501
        :type: str
        """

        self._external_customer_id = external_customer_id

    @property
    def id(self):
        """Gets the id of this Customer.  # noqa: E501

        Customer ID  # noqa: E501

        :return: The id of this Customer.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Customer.

        Customer ID  # noqa: E501

        :param id: The id of this Customer.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def organization(self):
        """Gets the organization of this Customer.  # noqa: E501

        VCO IAM organization  # noqa: E501

        :return: The organization of this Customer.  # noqa: E501
        :rtype: str
        """
        return self._organization

    @organization.setter
    def organization(self, organization):
        """Sets the organization of this Customer.

        VCO IAM organization  # noqa: E501

        :param organization: The organization of this Customer.  # noqa: E501
        :type: str
        """

        self._organization = organization

    @property
    def status(self):
        """Gets the status of this Customer.  # noqa: E501

        Customer status  # noqa: E501

        :return: The status of this Customer.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Customer.

        Customer status  # noqa: E501

        :param status: The status of this Customer.  # noqa: E501
        :type: str
        """
        allowed_values = ["PENDING_CARD", "PENDING_APPROVAL", "ACTIVE", "DISABLED"]  # noqa: E501
        if (self._configuration.client_side_validation and
                status not in allowed_values):
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Customer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Customer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Customer):
            return True

        return self.to_dict() != other.to_dict()
